/*
 * Copyright
 *   2007 axYus - www.axyus.com
 *   2007 C.Marchand - christophe.marchand@axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.cp.xemelios.updater.config;

import java.util.ArrayList;
import java.util.Iterator;

import org.xml.sax.SAXException;

import fr.gouv.finances.cp.utils.xml.marshal.InvalidXmlDefinition;
import fr.gouv.finances.cp.utils.xml.marshal.XmlAttributes;
import fr.gouv.finances.cp.utils.xml.marshal.XmlMarshallable;
import fr.gouv.finances.cp.utils.xml.marshal.XmlOutputter;

public class ConfigurationModel implements XmlMarshallable {
	public static final transient String TAG="configuration";
	
	private String className;
	private ArrayList<ParamModel> params;

	public ConfigurationModel(String tagName) {
		super();
		params = new ArrayList<ParamModel>();
	}

	public void addCharacterData(String cData) throws SAXException {
	}

	public void addChild(XmlMarshallable child, String tagName) throws SAXException {
		if(ParamModel.TAG.equals(tagName)) params.add((ParamModel)child);
	}

	public XmlMarshallable getAttributes(XmlAttributes attributes) throws SAXException {
		className = attributes.getValue("class");
		return this;
	}

	public void marshall(XmlOutputter output) {
		output.startTag(TAG);
		output.addAttribute("class",className);
		for(Iterator<ParamModel> it=params.iterator();it.hasNext();)
			it.next().marshall(output);
		output.endTag(TAG);
	}

	public void validate() throws InvalidXmlDefinition {
	}
	public ConfigurationModel clone() {
		ConfigurationModel cm = new ConfigurationModel(TAG);
		cm.className=this.className;
		for(Iterator<ParamModel> it=params.iterator();it.hasNext();)
			cm.params.add(it.next());
		return cm;
	}

	public String getClassName() {
		return className;
	}

	public void setClassName(String className) {
		this.className = className;
	}

	public ArrayList<ParamModel> getParams() {
		return params;
	}

	public void setParams(ArrayList<ParamModel> params) {
		this.params = params;
	}

}
